package com.vendor.platform.ui.internal;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.platform.ui.internal.RC4;
import java.io.BufferedOutputStream;
import java.io.Closeable;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import org.eclipse.ui.WorkbenchEncoding;

public class EncryptZipUtil {
  static byte[] magicFlag = new byte[] { 113, 84, 57, 102, 0 };
  
  public static boolean decryptZip(File zipFile, File unzip) {
    OutputStream out = null;
    InputStream in = null;
    try {
      in = new FileInputStream(zipFile);
      byte[] buf = new byte[magicFlag.length];
      int len = in.read(buf);
      if (len != buf.length)
        return false; 
      int i;
      for (i = 0; i < len; i++) {
        if (buf[i] != magicFlag[i])
          return false; 
      } 
      buf = new byte[8];
      len = in.read(buf);
      if (len != buf.length) {
        i = 0;
        return i;
      } 
      long key = toLong(buf);
      byte[] fileBuf = new byte[4096];
      RC4 r = new RC4(String.valueOf(key).getBytes(WorkbenchEncoding.getWorkbenchDefaultEncoding()));
      out = new BufferedOutputStream(new FileOutputStream(unzip));
      long size = zipFile.length() - magicFlag.length - 8L;
      while (size > 0L) {
        int read = in.read(fileBuf);
        size -= read;
        if (read < fileBuf.length)
          fileBuf = shrinkByteArray(fileBuf, read); 
        byte[] b = r.rc4(fileBuf);
        out.write(b);
      } 
      return true;
    } catch (IOException e) {
      return false;
    } finally {
      close(in);
      close(out);
    } 
  }
  
  public static void close(Closeable in) {
    if (in != null)
      try {
        in.close();
      } catch (IOException e) {
        e.printStackTrace();
      }  
  }
  
  static byte[] toBytes(long s) {
    byte[] buf = new byte[8];
    for (int i = buf.length - 1; i > 0; i--) {
      buf[i] = (byte)(int)(s & 0xFFL);
      s >>= 8L;
    } 
    return buf;
  }
  
  private static long toLong(byte[] buf) {
    long val = 0L;
    for (int i = 0; i < buf.length; i++) {
      val <<= 8L;
      val |= (buf[i] & 0xFF);
    } 
    return val;
  }
  
  private static byte[] shrinkByteArray(byte[] fileBuf, int size) {
    byte[] r = new byte[size];
    System.arraycopy(fileBuf, 0, r, 0, Math.min(fileBuf.length, size));
    return r;
  }
  
  public static boolean isEncrypted(File file) {
    InputStream in = null;
    try {
      in = new FileInputStream(file);
      byte[] buf = new byte[magicFlag.length];
      int len = in.read(buf);
      if (len != buf.length)
        return false; 
      int i;
      for (i = 0; i < len; i++) {
        if (buf[i] != magicFlag[i])
          return false; 
      } 
      i = 1;
      return i;
    } catch (Exception e) {
      return false;
    } finally {
      close(in);
    } 
  }
  
  public static void cleanFolder(File file) {
    if (!file.exists())
      return; 
    if (file.isDirectory()) {
      File[] files = file.listFiles();
      if (files != null)
        for (int i = 0; i < files.length; i++)
          cleanFolder(files[i]);  
    } else if (!file.delete()) {
      return;
    } 
  }
}
